#!/usr/bin/perl

BEGIN { @AnyDBM_File::ISA = qw(DB_File GDBM_File NDBM_File ) };

$PRG = 'dBs Item Viewer';
$VER = '0.3.0';

## $PRG - Version $VER
## (c) 1999/2000 by Massimiliano Pala
## OpenCA Core Developer
##
## (OpenCA Project)
##
## Description:
## ============
##
## This Program let you get an Item from one DB

print "\n$PRG - Version $VER\n";
print "(c) 1999/2000 by Massimiliano Pala\n";
print "OpenCA Core Developer\n\n";
print "(OpenCA Project)\n\n";

print "Enter The dBs dir ( db/ ) ? ";
$DIR = <STDIN>;
chop($DIR);

if( "$DIR" eq "" ) {
	$DIR = 'db';
}

print "Enter The dB name ( i.e. requests/certificates/... ) ? ";
$FILE = <STDIN>;
chop($FILE);

if( "$FILE" eq "" ) {
	$FILE = 'requests';
}

print "Enter The Item INDEX : ";
$idx = <STDIN>;
chop($idx);

$EXPORT_ALL=0;

if( not $idx ) {
	print "No index was given, do you want to extract all certs (y/N) ? ";
	$tmp= <STDIN>;
	chop($tmp);
	if( ( uc("$tmp") eq "N") or (not $tmp)) {
		print "ok, see you.\n\n";
		exit 0;
	};

	$EXPORT_ALL=1;
}	

$DBM_FILE = "$DIR/$FILE";

dbmopen( %DB, "$DBM_FILE", undef ) || die "Can't access DB!";
	if( $EXPORT_ALL ) {
		while ( ($key, $value) = each  %DB ) {
			print "Viewing item: ";
			print "( $key )  dim. " . length($value) . " bytes\n\n";

			print "Item DATA:\n";
			print "$value\n\n";
		}
	}
	else
	{

		$value=$DB{$idx};
		if( ! $value ) {
			print "Error, ITEM not present in DB.\n\n";
			exit 101;
		}

		print "Viewing item: ";
		print "( $idx )  dim. " . length($value) . " bytes\n\n";

		print "-----BEGIN ITEM DATA-----\n";
		print "$value";
		print "-----END ITEM DATA-----\n";
	}
dbmclose( %DB );

exit 0;
